<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//BARMAZ_MODULE_INFO

defined('_BARMAZ_VALID') or die("Access denied");

class blogModellist extends SpravModel {
	public function save(){
		$psid=parent::save();
		if ($psid) {
			$this->updateAlias($psid, Request::getSafe('b_alias',""), Request::getSafe('b_name',""));
		} else return 0;
		return $psid;
	}
	public function getBlog($blogId) {
		$blog=false;
		$query = "SELECT * FROM `#__blogs` WHERE `b_id`=".intval($blogId);
		$this->_db->setQuery($query);
		$this->_db->loadObject($blog);
		return $blog;
	}
	public function getBlogs() {
		$query = "SELECT * FROM #__blogs ORDER BY b_name";
		$this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}
	public function cleanBlogsLinks(){
		// удаленные посты
		$query = "DELETE FROM #__blogs_posts WHERE p_deleted=1";
		$this->_db->setQuery($query); if(!$this->_db->query()) return false; 
		// посты к удаленным блогам
		$query = "DELETE FROM #__blogs_posts WHERE p_blog_id NOT IN (SELECT b_id FROM #__blogs)";
		$this->_db->setQuery($query); if(!$this->_db->query()) return false; 
		// права на блоги
		$query = "DELETE FROM #__blogs_rights WHERE b_id NOT IN (SELECT b_id FROM #__blogs)";
		$this->_db->setQuery($query); if(!$this->_db->query()) return false; 
		// линки на блоги
		$query = "DELETE FROM #__blogs_links WHERE b_id NOT IN (SELECT b_id FROM #__blogs)";
		$this->_db->setQuery($query); if(!$this->_db->query()) return false;
		// тэги 
		$query = "DELETE FROM #__tags WHERE t_module_name='".$this->getModule()->getName()."' AND t_object_id NOT IN (SELECT p_id FROM #__blogs_posts)";
		$this->_db->setQuery($query); if(!$this->_db->query()) return false;
		// комментарии к постам удаленных блогов
		if(BaseComments::getInstance()->init("blog","post")){
			$query="SELECT p_id FROM #__blogs_posts";
			$this->_db->setQuery($query);
			$post_arr=$this->_db->loadResultArray();
			if(count($post_arr)){
				return BaseComments::getInstance()->cleanComments($post_arr);
			}
		}
		return true;
	}
	public function cleanRecords()	{
		if(parent::cleanRecords()) return $this->cleanBlogsLinks();	else return false;
	}
}