<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : service 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.1 (2023/09/29)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class serviceControllerdefault extends SpravController {

	private $start_path=BARMAZ_UF_PATH;
	private $start_link=BARMAZ_UF;
	private static $_hiddenfiles=array('.', '..',	'.svn', 'index.php', 'index.html',	'.htaccess','.htpasswd','web.config');
//	private $memory_limit=196;
	private $max_execution_time=300;
	
	// @TODO Придумать что-то другое когда будут не только виджеты
	public function showCachemanager(){
		$this->checkACL("viewCacheManager");
		$folders=Files::getFolders(PATH_CACHE, self::$_hiddenfiles, false);
		$view=$this->getView();
		$view->assign("folders", $folders);
		if ($folders)	{
			foreach($folders as $folder) {
				$files=Files::getFiles(PATH_CACHE.$folder["filename"].DS, self::$_hiddenfiles);
				$view->assign($folder["filename"]."_files", $files);
			}
		}
	}
	public function showUserfilter() {
		$view=$this->getView();
		$model=$this->getModel('cachemanager');
		$filtercount=$model->getFilterCount();
		$view->assign("filtercount", $filtercount);
	}
	public function clearUserFilter(){
		$view=$this->getView();
		$model=$this->getModel('cachemanager');
		$model->clearUserFilter(0);
		$this->setRedirect("index.php",Text::_('Cleared all filter records'));
	}

	public function deleteCacheFolder(){
		$this->checkACL("viewCacheManager");
		$folder=Request::getSafe("folder","");
		$files=Files::getFiles(PATH_CACHE.$folder.DS, self::$_hiddenfiles);
		if ($files){
			foreach ($files as $file){
				Files::delete(PATH_CACHE.$folder.DS.$file["filename"], true);
			}
		}
		$msg=Text::_("Operation complete");
		$this->setRedirect("index.php?module=service&view=cachemanager", $msg);
	}
	public function deleteCacheFile(){
		$this->checkACL("viewCacheManager");
		$folder=Request::getSafe("folder","");
		$file=Request::getSafe("file","");
		if (Files::delete(PATH_CACHE.$folder.DS.$file, true)) $msg=Text::_("Operation complete");	
		else $msg=Text::_("File delete error");
		$msg=Text::_("Operation complete");
		$this->setRedirect("index.php?module=service&view=cachemanager", $msg);
	}
	/* Резервное копирование таблиц БД */
	public function showDb(){
		$this->checkACL("viewDatabase");
		$backup_path = str_replace(DS.DS, DS, str_replace("/", DS, backofficeConfig::$backupPath).DS);
		if(!is_dir($backup_path)) $backup_path=PATH_FRONT.".backup".DS;
		$view=$this->getView();
		switch($this->get('layout')) {
			case "export":
				$tables = Exporter::getInstance()->getTablesList();
				$view->assign("tables",$tables);
				$view->assign("backup_path", $backup_path);
				$file="dbexport_".date("Ymd")."_".date("Gi").".sql";
				$view->assign("file", $file);
			break;
			default:
				$files=Files::getFiles($backup_path);
				$view->assign("files", $files);
				$view->assign("backup_path", $backup_path);
			break;
 		}
		
	}
	public function exportTables() {
		// FIXME говорят что phpmyadmin не поднимает
		$this->checkACL("viewDatabase");
		$backup_path = str_replace(DS.DS, DS, str_replace("/", DS, backofficeConfig::$backupPath).DS);
		if(!is_dir($backup_path)) $backup_path=PATH_FRONT.".backup".DS;
		$file=Request::getSafe("file","");
		$model=Module::getInstance()->getModel('db');
		$model->backupDB($backup_path,$file);
		$msg=Text::_("Operation complete");
		$this->setRedirect("index.php?module=service&view=db", $msg);
	}
	public function deleteBackup() {
		$this->checkACL("viewDatabase");
		$backup_path = str_replace(DS.DS, DS, str_replace("/", DS, backofficeConfig::$backupPath).DS);
		if(!is_dir($backup_path)) $backup_path=PATH_FRONT.".backup".DS;
		$file=Request::getSafe("file","");
		if (Files::delete($backup_path.$file, true)) $msg=Text::_("Operation complete");	
		else $msg=Text::_("File delete error");
		$this->setRedirect("index.php?module=service&view=db", $msg);
	}
	/* Медиа менеджер */
	public function startMediamanager($ajax=true) {
		if ($ajax) Portal::getInstance()->disableTemplate();
		$this->checkACL("viewMediamanager");
		$this->set('view','mediamanager',true);
		$model=Module::getInstance()->getModel();
		$return_element=Request::getSafe("ret_elem",""); // ид элемента в который вернуть значение
		$nfl=Request::getInt("nfl"); // 0 - относительный путь файла
		$folder=Session::getVar("mediamanager_last_folder");
		if(!is_null($folder)) $folder=$model->parsePath($folder,"",0);
		else $folder=$model->parsePath("","",0);
		$files=$model->getFiles($folder);
		if($files === false) $folder="";
		$files=$model->getFiles($folder);
		$view=$this->getView();
		$view->assign("folder",$folder);
		$view->assign("files",$files);
		$filepath = BARMAZ_UF_PATH.str_replace("/",DS,$folder);
		$view->assign("info_message","");
		$view->assign("error_class","");
		$view->assign("filepath",$filepath);
		$view->assign("is_ajax",$ajax);
		$view->assign("return_element",$return_element);
		$view->assign("nfl",$nfl);
		$view->renderFull ();
		$this->haltView();
	}
	public function showMediamanager() {
		$this->startMediamanager(false);
	}
	/* Медиа менеджер */
	public function startEditorFileBrowser($ajax=true) {
		if ($ajax) Portal::getInstance()->disableTemplate();
		if($this->checkACL("viewMediamanager",false)){
			$data=array();
			Event::raise("editor.mediamanager_params", array("file_browser_mode"=>"browser"), $data);
			if(array_key_exists("file_browser_path", $data) && is_file($data["file_browser_path"])){
				require_once($data["file_browser_path"]);
			}
		}
	}
	public function getLink() {
		$this->checkACL("viewMediamanager");
		Portal::getInstance()->disableTemplate();
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$ret_elem=Request::getSafe("ret_elem","");
		$folder=$model->parsePath($folder,$goto,$up);
		$file=Request::getSafe("file","");
		$nfl=Request::getInt("nfl"); // "0" - относительный путь файла, "-1" - относительный путь файла без userfiles
		if (Files::validFileName($file)) {
			$filelink=$model->getFileLink($folder,$file,$nfl);
			if(!$filelink) echo Text::_("Link error"); 
			else {
				if (!$ret_elem) {
					if ($nfl) echo "<b>".Text::_("Full file link").": </b>";
					else  echo "<b>".Text::_("Relative file link").": </b>";
				}
				echo $filelink;
			}
		} else echo Text::_("Wrong file name");
		Util::halt();
	}
	public function downloadBackup(){
		$this->checkACL("viewDatabase");
		$model=Module::getInstance()->getModel('db');
		$backup_path = str_replace(DS.DS, DS, str_replace("/", DS, backofficeConfig::$backupPath).DS);
		if(!is_dir($backup_path)) $backup_path=PATH_FRONT.".backup".DS;
		$file=Request::getSafe("file","");
		$href=Router::_("/administrator/index.php?module=service&view=db");
		if (Files::validFileName($file)) {
			$model->downloadFile($backup_path, $file, $href);
		} else {
			$this->setRedirect($href, Text::_("Wrong file name"));
		}
		
	}
	public function downloadFile() {
		$this->checkACL("viewMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		$file=Request::getSafe("file","");
		$href="index.php?module=service&view=mediamanager&folder=".$folder;
		if (Files::validFileName($file)) {
			$model->downloadFile($folder,$file,$href);
		} else {
			$this->setRedirect($href, Text::_("Wrong file name"));
		}
	}
	public function showMailerlog(){
		$this->showData();
	}
	public function cleanMailerlog(){
		$this->checkACL("viewServiceMailerlog");
		$model=Module::getInstance()->getModel("mailerlog");
		$model->cleanMailerlog();
		$this->showMailerlog();
	}
/**************************************************/
/*************** Ajax media manager ***************/	
/**************************************************/
	public function ajaxgetMediaContent($info_message="",	$is_error=false) {
		Portal::getInstance()->disableTemplate();
		$this->checkACL("viewMediamanager");
		$this->set('view','mediamanager',true);
		$model=Module::getInstance()->getModel();
		$folder=Request::getSafe("folder","");
		$goto=Request::getSafe("go_to","");
		$up=Request::getInt("is_up",0);
		$folder=$model->parsePath($folder,$goto,$up);
		$files=$model->getFiles($folder);
		if($files === false) $folder="";
		$files=$model->getFiles($folder);
		$view=$this->getView();
		$view->assign("folder",$folder);
		$view->assign("files",$files);
		$filepath = $this->start_path.str_replace("/",DS,$folder);
		$view->assign("filepath",$filepath);
		$view->assign("info_message",$info_message);
		if ($is_error) $view->assign("error_class","error_message");
		else $view->assign("error_class","");
		$view->render();
	}
	public function ajaxdeleteMediaFolder() {
		$is_error=true;
		$this->checkACL("useMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		$dir=Request::getSafe("oldfolder","");
		$href="index.php?module=service&view=mediamanager&folder=".$folder;
		$error_message="";
		if (Files::validFolderName($dir)) {
			$folder=str_replace("/",DS,$folder);
			if (!$dir) $error_message = Text::_("Folder delete error")." : ".$dir;
			else {
				if ($folder) $_dir = $this->start_path.DS.$folder.DS.$dir;
				else $_dir = $this->start_path.DS.$dir;
				if(is_dir($_dir)){
					if (Files::folderIsEmpty($_dir)) {
						if(rmdir($_dir)) {
							$error_message = Text::_("Folder deleted")." : ".$dir;
							$is_error=false;
						}	else $error_message = Text::_("Folder not deleted")." : ".$dir;
					} else $error_message = Text::_("Folder not empty")." : ".$dir;
				} else 	$error_message = Text::_("Folder not exists")." : ".$dir;
			}	
		} else {
			$error_message=Text::_("Wrong folder name");
		}
		$this->ajaxgetMediaContent($error_message,$is_error);
	}
	public function ajaxcreateMediaFolder() {
		$is_error=true;
		$this->checkACL("useMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		$dir=Request::getSafe("newfolder","");
		if (Files::validFolderName($dir)) {
			$folder=str_replace("/",DS,$folder);
			if ($folder) $_dir = $this->start_path.DS.$folder.DS.$dir;
			else $_dir = $this->start_path.DS.$dir;
			if(!is_dir($_dir)){
				if(!mkdir($_dir, 0755, true)) $error_message=Text::_("Folder not created")." : ".$dir;
			} else 	$error_message=Text::_("Folder already exists")." : ".$dir;
			$error_message=Text::_("Folder created")." : ".$dir;
			$is_error=false;
		} else {
			$error_message=Text::_("Wrong folder name");
		}
		$this->ajaxgetMediaContent($error_message,$is_error);
	}
	public function ajaxdeleteMediaFile() {
		$is_error=true;
		$this->checkACL("useMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		$file=Request::getSafe("file","");
		if (Files::validFileName($file)) {
			if (in_array($file, self::$_hiddenfiles)) Util::redirect($href, Text::_("File not exists")." : ".$file);
			$folder=str_replace("/",DS,$folder);
			if (!$file) $error_message = Text::_("File delete error")." : ".$file;
			if ($folder) $fullname = $this->start_path.DS.$folder.DS.$file;
			else $fullname = $this->start_path.DS.$file;
			if(is_file($fullname)){
				if(unlink($fullname)) {
					$error_message = Text::_("File deleted")." : ".$file;
					$is_error=false;
				}
				else $error_message = Text::_("File not deleted")." : ".$file;
			} else $error_message = Text::_("File not exists")." : ".$file;
		} else {
			$error_message = Text::_("Wrong file name");
		}
		$this->ajaxgetMediaContent($error_message,$is_error);
	}
	
	public function ajaxcreateMedia() {
		$is_error=true;
		$this->checkACL("useMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		
		$fieldname="up_file";
		if(isset($_FILES[$fieldname]['tmp_name'])) {
			Debugger::getInstance()->message('File uploaded. Type:'.$_FILES[$fieldname]['type'].'.  Name: '.$_FILES[$fieldname]['name']);
			if(is_uploaded_file($_FILES[$fieldname]['tmp_name'])) {
				if ($folder) $upload_dir = $this->start_path.DS.$folder;
				else $upload_dir = $this->start_path;
				if (is_dir($upload_dir)) {
					$file=$_FILES[$fieldname]['name'];
					if (Files::validFileName($file)) {
						if (in_array($file, self::$_hiddenfiles)) $error_message = Text::_("File allready exists")." : ".$file;
						$fullpath=$upload_dir.DS.$file;
						if (file_exists($fullpath)) {
							$error_message = Text::_("File allready exists")." : ".$file;
						} else {
							$tmp_name=$_FILES[$fieldname]['tmp_name'];
							$flag = copy($tmp_name,$fullpath);
							if($flag) { $error_message = Text::_("File uploaded")." : ".$file; $is_error=false; }
							else  $error_message = Text::_("Error copying file")." : ".$file;
						}
					} else $error_message = Text::_("Wrong file name");
				} else $error_message = Text::_("Folder not exists");
			} else $error_message = Text::_("File upload failed");
		} else $error_message = Text::_("File upload failed");
		$this->ajaxgetMediaContent($error_message,$is_error);
	}
	
	/* updater */
	public function showUpdater() {
		$this->checkACL("viewUpdater");
		$model=Module::getInstance()->getModel();
		switch($this->get('layout')) {
			case "restructure":
				$version=intval(Settings::getVar("restruct_version"));
				$current_version = Portal::getInstance()->getVersionRevision();
				break;
			default:
				$version=$model->getVersion();
				if($version=='0') $current_version=$version;
				else $current_version=$model->checkNewVersion();
				break;
		}
		$view=$this->getView();
		$view->assign("url",$model->getUrl());
		$view->assign("current_version",$current_version);
		$view->assign("version",$version);
	}
	public function restructureDB(){
		$this->checkACL("viewUpdater");
		$model=Module::getInstance()->getModel();
		$version=intval(Settings::getVar("restruct_version"));
		$current_version = Portal::getInstance()->getVersionRevision();
		if ($current_version > $version) {
			$view=$this->getView();
			$view->setLayout('restructure_result');
			$view->assign('result', $model->proceedDbRestructure($current_version));
			$view->assign('packagelog', $model->getLog());
			$view->render();
		} else {
			$this->setRedirect("index.php", Text::_("Your database does not need restructuring"));
		}
	}
	public function downloadUpdates() {
//		if(intval(adminConfig::$adminMemoryLimit) < $this->memory_limit) ini_set('memory_limit', $this->memory_limit."M");
		if(intval(adminConfig::$adminTimeLimit) < $this->max_execution_time) ini_set('max_execution_time', $this->max_execution_time);
		$this->checkACL("viewUpdater");
		$model=Module::getInstance()->getModel();
		$current_version=$model->checkNewVersion();
		$version=$model->getVersion();
		if ($current_version > $version) {
			$view=$this->getView();
			if ($model->processPackage()) $view->setLayout('confirm');
			else $view->setLayout('updated');
			$view->assign('packagelog',$model->getLog());
			$view->render();
		} else {
			$this->setRedirect("index.php", Text::_("Your version is up-to-date"));
		}
	}
	public function applyUpdates() {
//		if(intval(adminConfig::$adminMemoryLimit) < $this->memory_limit) ini_set('memory_limit', $this->memory_limit."M");
		if(intval(adminConfig::$adminTimeLimit) < $this->max_execution_time) ini_set('max_execution_time', $this->max_execution_time);
		$this->checkACL("viewUpdater");
		$model=Module::getInstance()->getModel();
		$current_version=$model->checkNewVersion();
		if ($current_version > $model->getVersion()) {
			$result=$model->processUpdates($current_version);
			$view=$this->getView();
			$view->setLayout('updated');
			$view->assign('packagelog',$result);
			$view->render();
		} else {
			$this->setRedirect("index.php", Text::_("Your version is up-to-date"));
		}
	}
	// редактирование дополнительных меню
	public function showAddMenu(){
		// @todo - дописать  управление доп элементами меню из админки
		$this->showData();
	}
	public function showAclRules(){
		$model=$this->getModel();
		$view=$this->getView();
		$message=array();
		// проверка доступов к модулям системы для админа
		if($model->checkModulesAccess($message)){
			$model->checkModulesAcl($message);
		}
		$view->assign('message',$message);		
	}
	public function showImageprocessor(){
		$model=$this->getModel();
		$mm=$this->getModel('mediamanager');
		$view=$this->getView();
		$message=array();
		$objects = $model->getImageObjects();
		//Util::showArray($_REQUEST);		
		$folder=Session::getVar("mediamanager_last_folder");
		if(!is_null($folder)) $folder=$mm->parsePath($folder,"",0);
		else $folder=$mm->parsePath("","",0);
		$filepath = BARMAZ_UF_PATH.str_replace("/",DS,$folder);
		$view->assign("filepath",$filepath);
		$view->assign('objects', $objects);
		$view->assign('message', $message);

	}
	public function ajaxprocessResize(){
		$this->processResize(true);
	}
	public function ajaxprocessWebpcreate(){
		$this->processWebpcreate(true);
	}
	
	/**
	 * отображение на форме интерфейса для выбора данных, подлежащих обработке 
	 */
	public function ajaxsetSelectField()
	{
		//Util::showArray($_REQUEST);
		$data=Request::getSafe('lim');
		$html='';
		// разбираем ключ на составляющие catalog_goodsgroup
			 
		$confdata=explode("_",$data);
		// конструкция у нас жесткая  и все заранее прописано :	
		$module=$confdata[0];
		$view=$confdata[1];
		//$layout=$confdata[2];
		//$fld=$confdata[3];
		$wdb=Database::getInstance();
		$s_name="w_where_select";
		$s_name_cat="w_where_select_cat";
		$html.='<div>';
		switch($module){
			case 'catalog':
				//switch($view){
				//	case 'goodsgroup':
				$html.="<span> Группа товаров ,начиная с которой(включительно) будет выполняться 
				преобразование отмеченных полей </span>";
				$grpTree=Module::getHelper('groupsTree','catalog');
				$html.=$grpTree->getTreeHTML(0, "select", $s_name);
				// добавляем сведения по таблице и полю
				$html.=HTMLControls::renderHiddenField('wcp_module',$module);
				$html.=HTMLControls::renderHiddenField('wcp_view',$view);
				//$html.=HTMLControls::renderHiddenField('wcp_layout',$layout);
				//$html.=HTMLControls::renderHiddenField('wcp_fld',$fld); 
				break;
						
				//}
			case 'blog':
				$html.="<span> Категория блогов ,начиная с которой(включительно) будет выполняться
				преобразование отмеченных полей </span>";
				
				$grpTree=Module::getHelper('categoriesTree','blog');
				$html.=$grpTree->getTreeHTML(0, "select", $s_name_cat);
				// сам список блогов
				
				$query = "SELECT * FROM #__blogs ORDER BY b_name";
				$wdb->setQuery($query);
				$list_blogs=$wdb->loadObjectList();
				$html.="<p>Блог , в котором проводятся преобразования. \"Не выбрано\" : будут обработаны все блоги  </p>";
				$html.=HTMLControls::renderSelect($s_name, $s_name, "b_id", "b_name", $list_blogs);
				
				
				// добавляем сведения по таблице и полю
				$html.=HTMLControls::renderHiddenField('wcp_module',$module);
				$html.=HTMLControls::renderHiddenField('wcp_view',$view);
				//$html.=HTMLControls::renderHiddenField('wcp_layout',$layout);
				//$html.=HTMLControls::renderHiddenField('wcp_fld',$fld);
				
				break;
			case 'gallery':
				break;
		}
		
		
		echo $html;
		
	}
	
	/**
	 * оптимизация изображений - преобразование в webp
	 * @param string $ajax
	 */
	public function startOptimize($ajax=false){
		
		/*
		 * // Image
$dir = 'img/countries/';
$name = 'brazil.webp';
$newName = 'brazil.webp';

// Create and save
$img = imagecreatefrompng($dir . $name);
imagepalettetotruecolor($img);
imagealphablending($img, true);
imagesavealpha($img, true);
imagewebp($img, $dir . $newName, 100);
imagedestroy($img);
		 * */
		
	}
	
	public function processResize($ajax=false){
		$image_object = false;
		$error_message = "";
		$total_records = 0;
		$status = array("status"=>"unknown", "message"=>"", "error_message"=>"", "next_start"=>0);
		$records_per_pass=intval($this->getConfigVal("process_records_per_pass"));
		
		$start=Request::getInt("start", 1);
		$field_key=Request::getSafe("field_key");
		$enabled_only=Request::getInt("enabled_only");
		$skip_deleted=Request::getInt("skip_deleted");
		$force_from_source=Request::getInt("force_from_source");
		$i_understand=Request::getInt("i_understand");
		
		if($this->checkACL("useImageProcessor", false)){
			if(Request::getMethod()=="POST"){
				if($i_understand){
					$model=$this->getModel();
					$image_object=$model->getImageObject($field_key);
					if($image_object){
						$total_records=$model->getTotalRecords($image_object, $enabled_only, $skip_deleted);
						if($ajax){
							// proceed resize
							if($start > $total_records){
								$status["status"]="finished";
								$status["message"]=Text::_("Operation complete").". <br />".Text::_("Records processed").": ".$total_records;
							} else {
								$status_arr=$model->resizeRecords($image_object, $start, $records_per_pass, $enabled_only, $skip_deleted, $force_from_source);
								$status["status"]="processing";
								$status["next_start"]=$start + $records_per_pass;
								$status["message"]=Text::_("Processing")." ".$start." ".Text::_("from")." ".$total_records;
								foreach($status_arr as $sk=>$sv){
									if($sv["status"]=="ERROR"){
										$status["error_message"].=($status["error_message"] ? "<br />" : "").$sv["message"];
									}
								}
							}
						}
					} else {
						$error_message=Text::_("Error while fetching image object data");
					}
				} else {
					$error_message=Text::_("Operation aborted");
				}
			} else {
				$error_message=Text::_("Operation aborted");
			}
		} else {
			$error_message=Text::_("Accees denied");
		}
		if($ajax){
			if($error_message) {
				// JSON error response
				$status["status"]="aborted";
				$status["message"]=$error_message;
			}
			echo json_encode($status);
		} else {
			$view=$this->getView();
			$view->setLayout("resize");
			$view->assign("image_object", $image_object);
			$view->assign("start", $start);
			$view->assign("field_key", $field_key);
			$view->assign("enabled_only", $enabled_only);
			$view->assign("skip_deleted", $skip_deleted);
			$view->assign("force_from_source", $force_from_source);
			$view->assign("i_understand", $i_understand);
			$view->assign("total_records", $total_records);
			$view->assign("records_per_pass", $records_per_pass);
			$view->assign("error_message", $error_message);
			$view->render();
		}
	}
	/**
	 * преобразование основной картинки изображений в webp формат
	 * из списка дополнительных изображений товара модуль каталог
	 * */
	
	public function ajaxcreateWebpImageByimages()
	{
		$id_goods=Request::getInt('psid');
		
		if($id_goods)
		{
			$model = $this->getModel ('imageprocessor');
			$img_inf=$model->getMainImgListByImages($id_goods);
			if($img_inf){
				$meta = new SpravMetadata('catalog','images','defl', true, true, 0);
				$field_index=-1;
				$upd='';
				foreach($img_inf as $fld=>$val)
				{
					if($val){
						$ext=Files::getExt($val);
						if($ext!=='webp')
						{
							foreach($meta->field as $kf=>$kv){
								if($kv==$fld){
									$field_index=$kf;
								}
							}
							if($field_index>-1){
								// у нас есть изображение не webp
								// можно начинать процесс его преобразования
								$dest_path=str_replace("/", DS, BARMAZ_UF_PATH.$meta->module.DS.$meta->upload_path[$field_index]).DS.Files::splitAppendix($val, true);
								// теперь создаем сам файл
								$res_create=true;
								$dest_img_name=Files::webpImage($dest_path,seoConfig::$qualityImage2Webp,false,$res_create);
								//Util::pre("res_create=".intval($res_create));
								// дополняем запрос
								if($res_create){
									$new_fname=Files::getName($val).".webp";
									$upd_str="`".$fld."` = '".$new_fname."'";
									$upd.=($upd ? ",".$upd_str : $upd_str);
								}
								
							}// есть такое поле в метадате
							
						}// расширение не webp есть что преобразовывать
					}// не пустое имя файла
				}// цикл по основным картинкам
				if($upd)
				{
					$sql="update #__goods_img set ".$upd;
					$sql.=" WHERE i_id=".(int)$id_goods;
					Database::getInstance()->setQuery($sql);
					$res_query=Database::getInstance()->query();
					if($res_query) echo "ОК"; return true;
				}
			}// вообще есть массив картинок по позиции
			
			
		}
		
	}
	
	
	/**
	 * преобразование основных картинок товара в webp формат 
	 * из карточки товара 	 модуль каталог
	 * */
	public function ajaxcreateWebpImageByGoods()
	{		
		$id_goods=Request::getInt('psid');
		
		if($id_goods)
		{
			$model = $this->getModel ('imageprocessor');
			$img_inf=$model->getMainImgListByGoods($id_goods);
			if($img_inf){
				$meta = new SpravMetadata('catalog','goods','defl', true, true, 0);
				$field_index=-1;
				$upd='';
				foreach($img_inf as $fld=>$val)
				{
					if($val){
						$ext=Files::getExt($val);
						if($ext!=='webp')
						{
							foreach($meta->field as $kf=>$kv){
								if($kv==$fld){
									$field_index=$kf;
								}
							}
							if($field_index>-1){
								// у нас есть изображение не webp
								// можно начинать процесс его преобразования
								$dest_path=str_replace("/", DS, BARMAZ_UF_PATH.$meta->module.DS.$meta->upload_path[$field_index]).DS.Files::splitAppendix($val, true);
								// теперь создаем сам файл
								$res_create=true;
								$dest_img_name=Files::webpImage($dest_path,seoConfig::$qualityImage2Webp,false,$res_create);
								//Util::pre("res_create=".intval($res_create));
								// дополняем запрос 
								if($res_create){
									$new_fname=Files::getName($val).".webp";
									$upd_str="`".$fld."` = '".$new_fname."'";
									$upd.=($upd ? ",".$upd_str : $upd_str);								
								}
							
							}// есть такое поле в метадате
							
						}// расширение не webp есть что преобразовывать
					}// не пустое имя файла
				}// цикл по основным картинкам
				if($upd)
				{
					$sql="update #__goods set ".$upd;
					$sql.=" WHERE g_id=".(int)$id_goods;
					Database::getInstance()->setQuery($sql);
					$res_query=Database::getInstance()->query();
					if($res_query) echo "ОК"; return true;
				}
			}// вообще есть массив картинок по позиции
			
			
		}
	}
	/* преобразование картинки в формат webp
	 * по идее логика следующая - 
	 * 1. получаем где и что преобразовываем (поле в базе что содержит упоминание для бюудущего пдейта + имя файла на диске с путем)
	 *    тут можно просто запрос получить уже готовый которым достанем файл
	 *    проверка на существование источника 
	 * 2. смотрим нет ли у нас уже такого файла (либо если есть флаг перезаписи - ваяем заново) 
	 * 3. получаем фапктические размеры картинки(возможно это не надо)
	 * 4. сохраняем файл в нужном формате рядом с источником
	 * 5. апдейтим запись в базе если нужно(тоже флаг дожен быть - вдруг мы просто с каталогом работали)
	 * 6. если есть флаг - удаляем источник   
	 * */
	
	public function processWebpcreate($ajax = false) {
		$image_object = false;
		$error_message = "";
		$total_records = 0;
		$status = array (
				"status" => "unknown",
				"message" => "",
				"error_message" => "",
				"next_start" => 0
		);
		$records_per_pass = intval ( $this->getConfigVal ( "process_records_per_pass" ) );
		$start = Request::getInt ( "start", 1 );
		$field_key = Request::getSafe ( "field_key" );
		$enabled_only = Request::getInt ( "w_enabled_only" );
		$skip_deleted = Request::getInt ( "w_skip_deleted" );
		$force_from_source = Request::getInt ( "w_force_from_source" );
		$i_understand = Request::getInt ( "w_i_understand" );
		$fldlst =Request::getSafe( "w_needfld" );
		// указатель на родителя по выборке
		$where_select=Request::getInt ( "w_where_select");
		if ($this->checkACL ( "useImageProcessor", false )) {
			if (Request::getMethod () == "POST") {
				if ($i_understand) {
					$model = $this->getModel ();
					// вот тут у нас есть вариант - когда нужно в выбранной папке папке поменять картинки
					// еще конечно имеет смысл как то уточнить все ли папки внутри надо просматривать
					if ($field_key == 'service_folders') {
						$service_folders=Request::getSafe ( "service_folders" );
						$service_folders_all=Request::getInt( "service_folders_all" );
						// может тут вообще функцию позвать, ее потом использовать
						$res_folder=$model->createWebpToFolders($service_folders,$service_folders_all);
						
						
					} else {

						// получаем списк полей в которых надо формировать замену
						$image_objects = $model->getImageObjectByModule ( $field_key );
						if (is_array ( $image_objects ) && count ( $image_objects ) > 0) {
							$check_obj = array ();
							$check_obj ['main'] = array ();
							$check_obj ['fld'] = array ();
							// тут фильтруем отмеченные поля
							$cntf = 0;
							$arr_fld = explode ( ",", trim ( $fldlst ) );
							$fld_list = '';
							foreach ( $image_objects as $kf => $vf ) {

								// есть это поле в выборке изначально или есть уже в наборе
								if (Request::getInt ( $kf ) || array_search ( $kf, $arr_fld ) !== false) {
									$cntf ++;
									if ($cntf == 1) {
										$check_obj ['main'] = $vf;
									}
									$check_obj ['fld'] [] = $vf;

									$fld_list .= ($fld_list ? "," : "") . $kf;
								}
							}
							if (count ( $check_obj ['fld'] ) == 0) {
								// у нас нет отмеченных для преобразования полей - выходим с уведомлением





								$error_message = Text::_ ( "The fields for image conversion are not checked" );
							} else {

								// есть поля - работаем
								// получаем имена полей

								$total_records = $model->getTotalRecordsForModule ( $check_obj ['main'], $enabled_only, $skip_deleted, $where_select );
								if ($ajax) {
									// proceed resize
									if ($start > $total_records) {
										$status ["status"] = "finished";
										$status ["message"] = Text::_ ( "Operation complete" ) . ". <br />" . Text::_ ( "Records processed" ) . ": " . $total_records;
									} else {
										// основная процедура обработки - все происхордит внутри по указанному набору и параметрам
										$status_arr = $model->webpRecords ( $check_obj, $start, $records_per_pass, $enabled_only, $skip_deleted, $force_from_source, $where_select );
										$status ["status"] = "processing";
										$status ["next_start"] = $start + $records_per_pass;
										$status ["message"] = Text::_ ( "Processing" ) . " " . $start . " " . Text::_ ( "from" ) . " " . $total_records;
										foreach ( $status_arr as $sk => $sv ) {
											if ($sv ["status"] == "ERROR") {
												$status ["error_message"] .= ($status ["error_message"] ? "<br />" : "") . $sv ["message"];
											}
										}
									}
								}
							}
						} else {
							$error_message = Text::_ ( "Error while fetching image object data" );
						}
					}// конец условия на замены по модулям 
				} else {
					$error_message = Text::_ ( "Operation aborted: rules not accepted" );
				}
			} else {
				$error_message = Text::_ ( "Operation aborted" );
			}
		} else {
			$error_message = Text::_ ( "Accees denied" );
		}
		if ($ajax) {
			if ($error_message) {
				// JSON error response
				$status ["status"] = "aborted";
				$status ["message"] = $error_message;
			}
			echo json_encode ( $status );
		} else {
			$view = $this->getView ();
			$view->setLayout ( "webp_create" );
			$view->assign ( "image_object", $image_object );
			$view->assign ( "start", $start );
			$view->assign ( "field_key", $field_key );
			$view->assign ( "w_needfld", $fld_list );
			$view->assign ( "w_enabled_only", $enabled_only );
			$view->assign ( "w_skip_deleted", $skip_deleted );
			$view->assign ( "w_force_from_source", $force_from_source );
			$view->assign ( "w_i_understand", $i_understand );
			$view->assign ( "w_where_select", $where_select );			
			$view->assign ( "total_records", $total_records );
			$view->assign ( "records_per_pass", $records_per_pass );
			$view->assign ( "error_message", $error_message );
			
			
			$view->render ();
		}
	}
	/**
	 * получаем информацию по типу поля , и формируем верстку для ввода 
	 * доп условий по этому полю
	 */
	public function ajaxsetSettingByType()
	{
		//Portal::getInstance()->disableTemplate();
		//Util::showArray($_REQUEST);
		$result="";
		$id_fld=Request::getInt("id_fld",0);
		$m_view=Request::getSafe('m_view',false);
		$m_module=Request::getSafe('m_module',false);
		$model=$this->getModel('db');
		if($id_fld){
			$res_info=$model->getAddFieldType($id_fld,$m_view);
			if($res_info->t_name=='image'){
				// верстаем параметры - возможно тут надо как то высчитать относится ли 
				// данный перенос сведжений  к каталогу
				
				// проверка на соответствие webp(надо или нет)
				$result.="<div class=\"row\">";
				$result.="<div class=\"col-md-4\">".HTMLControls::renderLabelField(false,Text::_ ( "Create webp image" ))."</div>";
				$result.="<div class=\"col-md-8\">".HTMLControls::renderCheckbox("m".$id_fld.'_create_webp',1,1,"create_webp")."</div>";
				$result.="</div>";
 				$result.="<div class=\"row\">";
				$result.="<div class=\"col-md-4\">".HTMLControls::renderLabelField(false,Text::_ ( "Set width image" ))."</div>";
				$result.="<div class=\"col-md-8\">".HTMLControls::renderInputText("m".$id_fld.'_d_width',CatalogConfig::$mediumImgWidth)."</div>";
				$result.="</div>";
				$result.="<div class=\"row\">";
				$result.="<div class=\"col-md-4\">".HTMLControls::renderLabelField(false,Text::_ ( "Set height image" ))."</div>";
				$result.="<div class=\"col-md-8\">".HTMLControls::renderInputText("m".$id_fld.'_d_height',CatalogConfig::$mediumImgHeight)."</div>";
				$result.="</div>";
				$result.="<div class=\"row\">";
				$result.="<div class=\"col-md-4\">".HTMLControls::renderLabelField(false,Text::_ ( "Apply watermark" ))."</div>";
				$result.="<div class=\"col-md-8\">".HTMLControls::renderCheckbox("m".$id_fld.'_appwm',0)."</div>";
				$result.="</div>";
				$result.="<div class=\"row\">";
				$result.="<div class=\"col-md-4\">".HTMLControls::renderLabelField(false,Text::_ ( "Remove file image" ))."</div>";
				$result.="<div class=\"col-md-2\">".HTMLControls::renderCheckbox("m".$id_fld.'_remove_img',1,1,"remove_img")."</div>";
				$result.="<div class=\"col-md-8\">".BARMAZ_UF_PATH.$m_module.DS.$m_view.DS.HTMLControls::renderInputText("m".$id_fld.'_d_path',"i/medium")."</div>";
				$result.="</div>";
			}else{
				$result.="<div class=\"row\"> => </div>";
			}
			
			
		}
		echo $result;
	}
	/**
	 * перенос данных из доп полей в основные таблицы
	 * выбор модуля , к которому относится таблица
	 * алгоритм:
	 * определяем основную таблицу и поля в ней требующие заполнения
	 * (поля должны быть добавлены, метадата под них подправлена)
	 * напротив каждого поля из таблицы выбираем доп поле содержащее информацию 
	 * допускается связка  один ко многим (по сути происходит денормализация данных)
	 * все заполняется на формуляре потом стартует для каждого
	 * @TODO опционально для работы на многих базах запоминаем  сценарий заполнения полей 
	 * в json    
	 */
	public function formDopData()
	{
		$model=$this->getModel('db');
		$view=$this->getView('db');
		$arr_tables=array();
		$_tables=$model->getAdditionalTableList();
		if(is_array($_tables))
		{
			foreach($_tables as $vl)
			{
				$arr_tables[$vl]=$vl;
			}
		}	
		$view->setLayout('formTableSelector');
		$view->assign('tables',$arr_tables);
		$view->render();		
	}
	/**
	 * панель выбора полей - что и куда переносим
	 */
	public function prepareReplacedata()
	{
		$model=$this->getModel('db');
		$view=$this->getView('db');
		$view->setLayout('formReplaceData');
		//Util::showArray($_REQUEST);
		$add_table=Request::getSafe('add_table',false);
		$count_fld=Request::getInt('count_fld',0);
		$err_message="";
		
		$_module=Request::getSafe('m_module','');
		$_view=Request::getSafe('m_view','');
		$_layout=Request::getSafe('m_layout','');
		$_side=Request::getInt('m_admin_side',0);
		$path="";
		if($_side) $path="administrator";
		$title="Обработка данных. Модуль ".$_module. " метадата ".$path."/modules/".$_module."/metadata/".$_view.".".$_layout.".php";
		$title.="<br /> Дополнительная таблица ".$add_table. " Число полей для переноса ".$count_fld;
		$main_meta=false;
		$main_key='';
		$arr_main_fld=array();
		if($_module&&$_view&&$_layout)
		{
		// получаем список полей основной таблицы из метадаты
			$main_meta = new SpravMetadata($_module, $_view, $_layout);
			
			if($main_meta){
				
				$fld_arr=$main_meta->field;
				$fld_name=$main_meta->field_title;
				$fld_type=$main_meta->val_type;
				$main_key=$main_meta->keystring;
				foreach($fld_arr as $kf=>$vf)
				{
					$arr_main_fld[$vf]=$fld_name[$kf]."(".$fld_type[$kf].")";
				}
				
				
			}
		//Util::showArray($main_meta);
		}else{
			$err_message.=Text::_("Not found data for metadata info");
		}
		$add_list=$model->getAdditionalTableFieldList($add_table);
		$view->assign('title',$title);
		$view->assign('err_mesage',$err_message);
		$view->assign('main_fld',$arr_main_fld );
		$view->assign('add_list',$add_list);
		$view->assign('main_table',$add_table);
		$view->assign('main_table_key',$main_key);
		$view->assign('count_fld',$count_fld);
		$view->assign('m_view',$_view);
		$view->assign('m_module',$_module);
		
		$view->render();
		
		
	}
	/**
	 * перевод данных в основную таблицу: основной алгоритм порционного переноса 
	 */
	public function ajaxremoveInMain()
	{
		//Util::showArray($_REQUEST);
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$reestr->set('view','db');
		$limit=request::getInt('lim',0);
		$json_data=request::get('json_data',false);
		$сur_offset=request::getInt('сur_offset',0);
		$inf=json_decode($json_data);
		
		//$view=$this->getView('db');
		$mod_remove=$this->getModel('db');
		//Util::showArray($inf,$limit." ".$сur_offset);
		$listrecord=$mod_remove->getRecordForRemove($limit,$inf,$сur_offset);
		//Util::showArray($listrecord);
		$objres=array();
		if($listrecord&&count($listrecord)>0)
		{
			$objres['res']="OK";
			foreach($listrecord as $keyrec=>$rec)
			{
				$startTime = microtime(1);
				$result=$mod_remove->removeRecordData($keyrec,$rec,$inf);
				if($result)
				{
					$objres['html'][$keyrec]['key']=$keyrec;
					$objres['html'][$keyrec]['result']=$result->result_db;
					$objres['html'][$keyrec]['nazv']=$result->msg;
					$objres['html'][$keyrec]['time']=microtime(1) - $startTime;
					$objres['html'][$keyrec]['color']='black';
				}
			}
		}
		else
		{
			$objres['res']="FALSE";
			$objres['html'][0]['result']="<span>Полей для переноса не обнаружено</span>";
		}
		
		echo json_encode($objres,JSON_UNESCAPED_UNICODE);
		//echo $this->json_encode2($objres);
	}
	public function removeDopData()
	{
		//Util::showArray($_REQUEST);
		$model=$this->getModel('db');
		
		$arr_add_fields=Request::getSafe('add_fld',array());
		$arr_main_fields=Request::getSafe('fld_table',array());
		$maintable=Request::getSafe('maintable','');
		$m_view=Request::getSafe('m_view',false);
		$m_module=Request::getSafe('m_module',false);
		$maintablekey=Request::getSafe('maintablekey','');
		$str_key_fields=implode(",",array_values($arr_add_fields));
		$str_name_fields=implode(",",array_values($arr_main_fields));
		$limit_remove=2; // лимит на перенос записей - это лимит на сами записи основной таблицы, возможно его надо в настройки выносить
		
		// вот тут формируем сценарий переноса
		$_data_remove=new stdClass();
		$_data_remove->table_dst=$maintable;
		$_data_remove->table_dst_key=$maintablekey;
		$_data_remove->keys_table_src=$str_key_fields;
		$_data_remove->fld_table_dst=$str_name_fields;
		
		
		
		$_data_remove->table_src=$maintable."_data";
		$fld_remove=array();
		foreach($arr_main_fields as $kf=>$vf)
		{
			$fld_list_s[$vf]=$arr_add_fields[$kf];
			$fld_list_d[$arr_add_fields[$kf]]=$vf;
			$dopinfo=new stdClass();
			$dopinfo->createWebp=Request::getBool("m".$arr_add_fields[$kf]."_create_webp",false);
			$dopinfo->d_width=Request::getInt("m".$arr_add_fields[$kf]."_d_width",0);
			$dopinfo->d_height=Request::getInt("m".$arr_add_fields[$kf]."_d_height",0);
			$dopinfo->appwm=Request::getBool("m".$arr_add_fields[$kf]."_appwm",false);
			$dopinfo->d_path_postfix=$m_module.DS.$m_view.DS.Request::getSafe("m".$arr_add_fields[$kf]."_d_path",false);
			$fld_remove[$vf]=$model->getAddFieldType($arr_add_fields[$kf],$m_module,$m_view,$dopinfo);
		}
		$_data_remove->fld_list_s=$fld_list_s;
		$_data_remove->fld_list_d=$fld_list_d;
		$_data_remove->fld_data=$fld_remove;
		//Util::showArray($_data_remove);
		$json_data=json_encode($_data_remove,JSON_UNESCAPED_UNICODE);
		
		//Util::showArray($_REQUEST);
		// ид доп полей
	/*	[0]	====> 	28 (typeof string)
		[1]	====> 	31 (typeof string)
		[2]	====> 	32 (typeof string)
		fld_table : array
		// наименование полей куда переносим 
		[0]	====> 	i_med_image (typeof string)
		[1]	====> 	i_alt_med_img (typeof string)
		[2]	====> 	i_title_med_img (typeof string
	*/	
		// получаем список позиций с преобразованными данными
		// тут возможно нужен цикл который будет преобразовывать операцию по частям
		// либо добавлять служебное поле обработки в основную таблицу данных
		// возможно это надо будет делать аджаксом
		//$listForUpdate=$model->prepareListForUpdate();
		$checkLostData=$model->checklostDopData($maintable,$maintablekey,false);
		//Util::showArray($checkLostData);
		$view=$this->getView();
		$view->assign("maintable",$maintable);
		$view->assign("maintablekey",$maintablekey);
		$view->assign("countLost",$checkLostData->count);
		$view->assign("title",Text::_("Remove data"));
		$view->assign("limit_remove",$limit_remove);
		$view->assign("str_fld_remove",$str_name_fields);
		$view->assign("json_data",$json_data);
		
		$view->assign("Records",$model->counterRemoveData($maintable,$maintablekey,$str_key_fields));
		$view->setLayout('formfld_process',true);
		$view->render();
	}
}
?>