<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : service 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.1 (2023/09/29)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class Restructure_186{
	public static function RestructureInfo(){
		$_info=array();
		$_info['core']="Управление дополнительными полями. Возможность временного выключения";
		$_info['modules']['catalog'][]="Поле уменьшенного изображения в дополнительных изображениях товаров";
		$_info['modules']['catalog'][]="Возможность отображения нескольких цен при печати прайс-листа";
		return $_info;
		
	}
	
	public static function proceed(&$messages, &$errors) {
		// Let's make something with database
		
		// поскольку таблицы разные - можно паралель выстраивать
		// какой то запрос да выполнится
		// 1. управление дополнительными полями
		$sql="ALTER TABLE `#__fields_list` ADD COLUMN `f_enabled` TINYINT(1) DEFAULT '1' NULL COMMENT 
		'признак временного выключения поля' after `f_extcode`,change `f_deleted` `f_deleted` smallint(1) default '0' NOT NULL comment 'признак удаления'".Database::getInstance()->getDelimiter();
		Database::getInstance()->setQuery($sql);
		if(!Database::getInstance()->query()){
			// Returning error if failed
			$errors[]=Text::_("Error applying restructure").": ".__CLASS__." db error ".Database::getInstance()->getLastError();
			//return false;
		}
		$sql="ALTER TABLE #__goods_img 
		ADD COLUMN `i_med_image` VARCHAR(64) DEFAULT '' NOT NULL,
		ADD COLUMN `i_title_med_img` varchar(255) NULL COMMENT 'тайтл средней картинки',
	    ADD COLUMN `i_alt_med_img` varchar(64) NULL COMMENT 'альтернативное описание средней картинки'"
		.Database::getInstance()->getDelimiter();
		Database::getInstance()->setQuery($sql);
		if(!Database::getInstance()->query()){
			// Returning error if failed
			$errors[]=Text::_("Error applying restructure").": ".__CLASS__." db error ".Database::getInstance()->getLastError();
			//return false;
		}
/*		$sql=" alter table `#__goods_priceset` change `p_price` `p_price` text NULL ".Database::getInstance()->getDelimiter();
		Database::getInstance()->setQuery($sql);
		if(!Database::getInstance()->query()){
			// Returning error if failed
			$errors[]=Text::_("Error applying restructure").": ".__CLASS__;
			return false;
		}
*/
		if(count($errors)>0) return false;
		// Returning message if successed
		$messages[]=__CLASS__;
		return true;
	}
}
?>