//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 


function mm_setContent(content){
	$('#mediamanager').html(content);
	if (typeof templateEveryLoad == 'function') templateEveryLoad('#mediamanager');
	mm_prepareUploader();
}

function setWebpProc(sel)
{
	/*
	 * отображение выбора данных для дальнейщей обработки 
	 * преобразования формата графических файлов
	 * */
	ajaxShowActivity();
	$.ajax({
		url : siteConfig['siteUrl']+"index.php",
		data:({
			type:'module',
			option:'ajax',
			module:'service',
			task:'setSelectField',
			lim:$(sel).val()
		}),
		dataType:'html',
		success: function (html_data, textStatus) {
			$("#selected_item").html(html_data);
			ajaxHideActivity();
		},
	    error: function (jqXHR, exception) {
	        var msg = getErrMsg(jqXHR, exception);
	        // возможно это имеет смысл только при включенном дебагере
	        console.log(msg);
	        ajaxHideActivity();
		}
	});
	
}

function mm_getContent(folder, go_to, is_up){
	ajaxShowActivity();
	$.ajax({
		url : siteConfig['siteUrl']+"index.php",
		data:({
			type:'module',
			option:'ajax',
			module:'service',
			task:'getMediaContent',
			folder:folder,
			go_to:go_to,
			is_up:is_up
		}),
		dataType:'html',
		success: function (html_data, textStatus) {
			mm_setContent(html_data);
			$.fancybox.resize();
			ajaxHideActivity();
		},
		error: function () { ajaxHideActivity(); return false; }
	});
}
function mm_deleteFolder(folder, oldfolder){
	if (confirm('Do you want to delete')) {
		ajaxShowActivity();
		$.ajax({
			url : siteConfig['siteUrl']+"index.php",
			data:({
				type:'module',
				option:'ajax',
				module:'service',
				task:'deleteMediaFolder',
				folder:folder,
				oldfolder:oldfolder
			}),
			dataType:'html',
			success: function (html_data, textStatus) {
				mm_setContent(html_data);
				$.fancybox.resize();
				ajaxHideActivity();
			},
			error: function () { ajaxHideActivity(); return false; }
		});
	}
}
function mm_createFolder(folder){
	var newfolder=$('#newfolder').val();
	if (newfolder !='') {
		ajaxShowActivity();
		$.ajax({
			url : siteConfig['siteUrl']+"index.php",
			data:({
				type:'module',
				option:'ajax',
				module:'service',
				task:'createMediaFolder',
				folder:folder,
				newfolder:newfolder
			}),
			dataType:'html',
			success: function (html_data, textStatus) {
				mm_setContent(html_data);
				$.fancybox.resize();
				ajaxHideActivity();
			},
			error: function () { ajaxHideActivity(); return false; }
		});
	}
}
function mm_deleteFile(folder, file){
	if (confirm('Do you want to delete')) {
		ajaxShowActivity();
		$.ajax({
			url : siteConfig['siteUrl']+"index.php",
			data:({
				type:'module',
				option:'ajax',
				module:'service',
				task:'deleteMediaFile',
				folder:folder,
				file:file
			}),
			dataType:'html',
			success: function (html_data, textStatus) {
				mm_setContent(html_data);
				$.fancybox.resize();
				ajaxHideActivity();
			},
			error: function () { ajaxHideActivity(); return false; }
		});
	}
}
function mm_setLink(folder, file){
	var ret_elem=$('#mm_return_element').val();
	var nfl=$('#mm_nfl').val();
	ajaxShowActivity();
	$.ajax({
		url : siteConfig['siteUrl']+"index.php",
		data:({
			type:'module',
			module:'service',
			task:'getLink',
			folder:folder,
			file:file,
			ret_elem:ret_elem,
			nfl:nfl
		}),
		dataType:'html',
		success: function (html_data, textStatus) {
			if (ret_elem !='') {
				$('#'+ret_elem).val(html_data);
				$('#'+ret_elem).trigger('change');
				$.fancybox.close();
			} else {
				$('#medialink').html(html_data);
			}
			ajaxHideActivity();
		},
		error: function () { ajaxHideActivity(); return false; }
	});
}
function mm_prepareUploader() {
	var bar = $('#mm_single_upload .bar');
	var percent = $('#mm_single_upload .percent');
	var status = $('#status');
	$('#mm_single_upload').ajaxForm({
		beforeSend: function() {
			status.empty();
			var percentVal = '0%';
			bar.width(percentVal)
			percent.html(percentVal);
			},
		uploadProgress: function(event, position, total, percentComplete) {
			var percentVal = percentComplete + '%';
			bar.width(percentVal)
			percent.html(percentVal);
		},
		success: function() {
			var percentVal = '100%';
			bar.width(percentVal)
			percent.html(percentVal);
		},
		complete: function(xhr) {
			mm_setContent(xhr.responseText);
			//status.html(xhr.responseText);
		}
	}); 
}
function mm_startMediaManager(ret_elem, nfl){
	ajaxShowActivity();
	$.ajax({
		url : siteConfig['siteUrl']+"index.php",
		data:({
			type: 'module',
			module: 'service',
			task: 'startMediamanager',
			ret_elem: ret_elem,
			nfl:nfl
		}),
		dataType:'html',
		success: function (html_data, textStatus) {
			$.fancybox({'content'	: html_data});		
			mm_prepareUploader();
			$.fancybox.resize();
			$('#fancybox-overlay').css('z-index','20000');
			$('#fancybox-wrap').css('z-index','20001');
			ajaxHideActivity();
		},
		error: function () { ajaxHideActivity(); return false; }
	});
}
/**
 * проверка соответствий и вывод информационых данных перед процедурой
 */
function checkaddFld(ind,side,elm)
{
	
	let vl=$(elm).val();
	
	// проверяем на заполненость соседнюю сторону
	// не ругаемся просто укажем что ее надо заполнить
	
	// если стороны заполнены то смотрим типы данных по обеим сторонам
	// тут нам возможно понадобится преобразование типов (вероятно надо проверять возможно ли преобразование)
	
	// если у нас файл то указываем путь к файлу приемника - говорим о том, что файл будет перенесен по новому пути
	
	// если у нас изображение и установлен признак автоматического преобразования webp - преобразовываем	
	// как то еще надо получить размеры изображений и проверить их на соответствие
	// опираемся на сторону доп таблицы -1 как приемника по ид - мы можем получить тип поля 
	// и от него уже формировать поля с доп параметрами
    if(side==1){
    	ajaxShowActivity();
	    $.ajax({
		url : siteConfig['siteUrl']+"index.php",
		data:({
			type: 'module',
			option:'ajax',
			module: 'service',
			task: 'setSettingByType',
		    m_view: $("#m_view").val(),
		    m_module: $("#m_module").val(),
		    id_fld: vl
		}),
		dataType:'html',
		success: function (html_data, textStatus) {
			
			// заполним допами если есть чем
			$("#inf"+ind).html(html_data);
			// удалили эту строку из списка выбора, во избежание двойной подстановки
			
			// надо удалять из всех селектов
			// разумно было бы перечитать селекты из внешнего для них общего источника 
			// предварительно удалив его    	
			//$(elm ":selected").remove();
			
			ajaxHideActivity();
		},
		error: function () { ajaxHideActivity(); return false; }
	});

	}	 
	
	    
console.log(ind,side,vl,$("#m_view").val(),$("#m_module").val());	
}
/**
 *@TODO проверка возможности совершить операцию переноса
 * все поля уникальны и  заполнены парами
 * 
 */
/**
 * перенос данных из доп полей в основную таблицу 
 */
var res_remove=true;
function RemoveProccess(limit_remove)
{
  if(limit_remove<=0) {
	  $("#js_report").append("<div class=\"row\"><div class=\"col-md-12\">Лимит на количество переносимых строк не установлен. Перенос не возможен. найдено строк для для переноса "+ItRecords+"</div></div>");
	  return false; // лимит должен быть
  }
  var cont=0;
  var maxIter=3;
  console.log("max iter "+maxIter);
  console.log("ItRecords "+ItRecords);
  var numIter=Math.floor(ItRecords/limit_remove);
  console.log("max iter rach "+numIter);
  if(numIter>maxIter) maxIter=numIter+50;
  while(res_remove&&cont<maxIter)
  {
	  cont++;
	  res_remove=remove_part(limit_remove);
	  CurCounterRecords=cont*limit_remove;
  }
  var elapsed = '';//(startTime.getTime() - startMsec) / 1000;
  $("#js_report").append("<div class=\"row\"><div class=\"col-md-12\">Всего итераций "+cont+" за "+elapsed+" сек. Обработано (прим ) "+(CurCounterRecords)+" записей</div></div>");

}
function remove_part(limit)
{
	if(limit==undefined) limit=10;
	var ret=false;
	var html='';
	ajaxShowActivity();
	//$('#barmaz-loading').show(); - может тут что-то показывать из информации о процессе
	
	$.ajax({
		// тут наверное еще надо передавать что и куда переносить
		url : "index.php",
		method:"POST",
		data:({type:'module',
			   option:'ajax',
			   module:'service',
			   task:'removeInMain',
			   lim:limit,
			   сur_offset:CurCounterRecords,
			   json_data:$("#json_data").val()
		   }),
		dataType:'json',
		async: false,
		success : function(data, textStatus) {
			
			console.dir(data);
			//if(data != null)
			if (data['res'] != null){
			if (data['res']=='OK'){
				var htmldata=data['html'];
				for( var key in htmldata)
				{
					html+="<div class=\"row\" style=\"color:"+htmldata[key]['color']+";\"><div class=\"col-md-6\">"+CurCounterRecords+" "+htmldata[key]['nazv']+" "+htmldata[key]['result']+"</div><div class=\"col-md-6\">Тип "+htmldata[key]['type']+" </td><td> Время "+htmldata[key]['time']+"</div></div>";
				}	
				ret=true;
				ajaxHideActivity();
				$("#js_report").append(html);
				
			}
			else
			{
				ret=false;
				html+="<div class=\"row\"><div class=\"col-md-12\">Перенос данных завершен</div></div>";
				ajaxHideActivity();
				$("#js_report").append(html);
			}
			}

		},
		error : function(er_obj) {
			// пришли неверные данные (нотайсы и прочие) - проверяем если у нас текущий номер калькуляции меньше общего количества - то 
			// выводим сообщение о неверной калькуляции - может еще сведения об ощибке на экран
			// иначе , если номер текущей итерации больше общего количтсва - то падаем
			//console.dir(er_obj);
			if(CurCounterRecords<ItRecords)
			{
				ret=false;
				html+="<div class=\"row\" style=\"color: #FF0090;\"><div class=\"col-md-12\" >"+CurCounterRecords+" Ошибка при переносе данных.<br />"+JSON.stringify(er_obj.responseText)+" <br /> Лимит не достигнут. Перенос данных продолжен</div></div>";
				if(confirm("Ошибка ! Продолжаем пересчет ")) ret=true;
				ajaxHideActivity();
				$("#js_report").append(html);
				return ret;
			}	
			else
			{	
			ret=false;
			alert('Server ERROR');
			ajaxHideActivity();
			return false;
			}
		}
	});
	return ret;
}
