<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : pools 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.0 (2023/04/04)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class pollsCustomRouter extends Router {
	public function parseRoute($request) {
		Debugger::getInstance()->message("Router (polls) parsed URI ".$request);
		$_result=preg_split('/[\/]/',$request);
		$module=""; $view=""; $layout=""; $psid="";$alias="";$page404=false;
		$last_element = preg_split('/(\.html)/',$_result[count($_result)-1]);
		if (preg_match('/(index.php)/',$last_element[0])) $last_element[0]="";
		if (preg_match('/(default)/',$last_element[0])) $last_element[0]="";
		$_result[count($_result)-1] = $last_element[0];
		switch (count($_result)) {
			case 2:
				$module = $_result[1];
				break;
			case 3:
				$module = $_result[1]; $view   = $_result[2];
				break;
			case 4:
				$module = $_result[1]; 	$view   = $_result[2];
				$alias=$_result[3];
				$psid = Module::getHelper("polls","polls",true)->getIdByAlias($view,$alias);
				if (!$psid) $psid=intval($_result[3]);
				if (!$psid) $page404=true;
				break;
			case 5:
				$module = $_result[1]; $view = $_result[2];
				$layout = $_result[3]; $alias=$_result[4];
				$psid = Module::getHelper("polls","polls",true)->getIdByAlias($view,$alias);
				if (!$psid) $psid=intval($_result[4]);
				if (!$psid) $page404=true;
				break;
			default:
				$page404=true;
				break;
		}
		$_vars = array();
		if ($module) $_vars['module']=$module;
		if ($view) $_vars['view']=$view;
		if ($layout) $_vars['layout']=$layout;
		if ($psid) $_vars['psid']=$psid;
		if ($alias) $_vars['alias']=$alias;
		if ($page404) $_vars['page404'] = $page404;
		return $_vars;
	}
	public function buildRoute($options, $mode="sitelink", $force_fronte=0, $absolute_link=0, $force_protocol=0) {
		$url = $options['module']; unset($options['module']);
		if (array_key_exists('multy_code', $options)) unset($options['multy_code']);
		if (array_key_exists('view', $options) && $options['view']) {
			$url.= "/".$options['view']; unset($options['view']);
			if (array_key_exists('layout', $options)) {
				$url.= "/".$options['layout']; unset($options['layout']);
			}
			if (array_key_exists('alias', $options) && $options['alias']) {
				$url.= "/".$options['alias']; unset($options['alias']); unset($options['psid']);
			} else {
				if (array_key_exists('alias', $options)) unset($options['alias']);
				if (array_key_exists('psid', $options)) {
					$url.= "/".$options['psid']; unset($options['psid']);
				}
			}
		}
		$url.=".html"; $appendix="";
		if (count($options)>0) {
			foreach($options as $key=>$val) {	$appendix.="&".$key."=".$val;	}
		}
		$url=Portal::getURI($force_fronte, $absolute_link, $force_protocol).$url;
		if ($appendix) $url=$url."?".substr($appendix,1);
		return $url;
	}
}
?>