<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//BARMAZ_CORE_INFO

defined('_BARMAZ_VALID') or die("Access denied");

class FieldSet {
	private $_defs	= array();
	public function get($key, $defaultValue='', $emty2default=false) {
		if (array_key_exists($key,$this->_defs)) {
			if($emty2default && !$this->_defs[$key]) return $defaultValue;
			else return $this->_defs[$key];
		}	else {
			return $defaultValue;
		}
	}
	public function set($key, $value='') {
		if (array_key_exists($key,$this->_defs)) {
			$oldValue = $this->_defs[$key];
		} else $oldValue = null;
		$this->_defs[$key] = $value;
		return $oldValue;
	}
	public function toArray() {
		return $this->_defs;
	}
}
?>